﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace Sample1
{
  public enum MinutesStatus
  {
    Incomplete,
    Errors,
    Complete
  }

  public enum PrintingStatus
  {
    Incomplete,
    Errors,
    Complete
  }

  public enum UploadStatus
  {
    UnCommitted,
    Errors,
    Committed
  }

  public enum FlaggedStatus
  {
    None,
    FollowUp
  }

  public class SettingItem : INotifyPropertyChanged
  {
    private MinutesStatus minutesStatus;
    private PrintingStatus printingStatus;
    private UploadStatus uploadStatus;

    private bool isSelected;

    public FlaggedStatus FlaggedStatus { get; set; }
    public Setting Setting { get; set; }
    public Collection<SubSetting> SubSettings { get; set; }

    public SettingItem()
    {
      SubSettings = new Collection<SubSetting>();
    }

    public MinutesStatus MinutesStatus
    {
      get
      {
        return this.minutesStatus;
      }
      set
      {
        if (value != this.minutesStatus)
        {
          this.minutesStatus = value;
          OnPropertyChanged("MinutesStatus");
        }
      }
    }

    public PrintingStatus PrintingStatus
    {
      get
      {
        return this.printingStatus;
      }
      set
      {
        if (value != this.printingStatus)
        {
          this.printingStatus = value;
          OnPropertyChanged("PrintingStatus");
        }
      }
    }

    public UploadStatus UploadStatus
    {
      get
      {
        return this.uploadStatus;
      }
      set
      {
        if (value != this.uploadStatus)
        {
          this.uploadStatus = value;
          OnPropertyChanged("UploadStatus");
        }
      }
    }

    public bool IsSelected
    {
      get
      {
        return this.isSelected;
      }
      set
      {
        if (value != this.isSelected)
        {
          this.isSelected = value;
          OnPropertyChanged("IsSelected");
        }
      }
    }

    public event PropertyChangedEventHandler PropertyChanged;

    public void OnPropertyChanged(string name)
    {
      PropertyChangedEventHandler handler = PropertyChanged;
      if (handler != null)
        handler(this, new PropertyChangedEventArgs(name));
    }
  }


  public class Sentence
  {
    public string Description { get; set; }
  }
}
